/* STAR.PRC

This program is to calculate the approximate LM test for a STAR model 

Bruce E. Hansen
Department of Economics
Social Science Building
University of Wisconsin
Madison, WI 53706-1393
bhansen@ssc.wisc.edu
http://www.ssc.wisc.edu/~bhansen/

*/

proc(2) = star(dat,p,omit);

local t,ro,k,k1,y,x,u,uu,e,ee,j,j1,f,s3,ps3;

@ Construct Data @
t=rows(dat)-p;
if omit==0;
 k=p;
else;
 ro=rows(omit);
 k=p-ro;
endif;
k1=k+1;
y=dat[1+p:t+p];
x=ones(t,1);
j=1;do while j<=p;
if sumc(omit.==j)==0;
 x=x~dat[1+p-j:t+p-j];
endif;
j=j+1;endo;

@ Null Model @
u=y-x*((x'y)/moment(x,0));
uu=u'u;


f=x~(x[.,2:k1].^2)~(x[.,2:k1].^3);
if k.>1;
 j=2;do while j<=k1;
  j1=j+1;do while j1<=k1;
   f=f~(x[.,j].*x[.,j1]);
  j1=j1+1;endo;
 j=j+1;endo;
endif;
e=u-f*((f'u)/moment(f,0));
ee=e'e;
s3=t*(uu-ee)/uu;
ps3=cdfchic(s3,(k1*k/2)+k);

retp(s3,ps3);
endp;

