/*  TAR.PRG

Bruce E. Hansen
Department of Economics
Social Science Building
University of Wisconsin
Madison, WI 53706-1393
bhansen@ssc.wisc.edu
http://www.ssc.wisc.edu/~bhansen/

This program replicates the empirical work reported in
"Inference when a nuisance parameter is not identified
under the null hypothesis."

It calls the procedures TAR.PRC and STAR.PRC and loads
the data GNP.ASC.

Refer to the procedure files for explanations.

*/

library pgraph;
pqgwin many;


load gnp[175,2]=gnp.asc;
yg=ln(gnp[.,1]);
y=(yg[2:175]-yg[1:174])*400;
let omit = 3 4;

output file=tar.out on;
output off;
#include tar.prc;
{t,p}=tar(y,5,omit,.15,.85,5000,1,1);

output file=tar.out on;
"";"";
#include star.prc;
{te,pe}=star(y,5,omit);
"STAR test " te~pe;
"";"";output off;
